/*

	Joystick test routine

 */

#include <stdlib.h>
#include <stdio.h>
#include <dos.h>
#include <ctype.h>
#include <string.h>
#include <conio.h>

struct _a26data
{
unsigned int nUp,nDown,nLeft,nRight;
char szId[32];
} A26;

void EXIT(char *s)
{
puts("Failed :");
puts(s);
puts("\n");
}

void GetJoystick(int *x,int *y)
{
union REGS r;
r.h.ah = 0x84;
r.x.dx = 1;
int86(0x15,&r,&r);
*x = r.x.ax;
*y = r.x.bx;
}

int ReadInt(char *szPrompt)
{
char szText[32];
printf(" %s >",szPrompt);
gets(szText);
return(atoi(szText));
}

int puti(int n)
{
if (n >= 10) puti(n / 10);
putchar((n % 10)+'0');
}

void main()
{
FILE *f;
char ch;
int x,y,x1,y1,x2,y2;
if (f = fopen("a26.com","rb"),f == NULL) EXIT("Couldn't open a26.com");
if (fseek(f,32L,SEEK_SET) != 0) EXIT("Couldn't seek a26.com");
if (fread(&A26,sizeof(A26),1,f) != 1) EXIT("Couldn't read a26.com");
fclose(f);
if (strcmp(A26.szId,"A26-Config") != 0) EXIT("Wrong version of a26/joy");
do
	{
	puts("A26 Joystick Calibration ");
	puti(A26.nUp);putchar('.');
	puti(A26.nDown);putchar('.');
	puti(A26.nLeft);putchar('.');
	puti(A26.nRight);
	puts("\n(T)est (M)anual (C)alibrate (Q)uit\n");
	ch = getch();
	ch = toupper(ch);
	switch(ch)
		{
		case 'C':	puts("Waggle the joystick for a bit,then Press any key\n");
					x1 = y1 = 9999;
					x2 = y2 = 0;
					while (!kbhit())
						{
						GetJoystick(&x,&y);
						if (x < x1) x1 = x;
						if (y < y1) y1 = y;
						if (x > x2) x2 = x;
						if (y > y2) y2 = y;
						}
					getch();
					x = (x1 + x2) / 2;
					y = (y1 + y2) / 2;
					x1 = (x - x1) / 2;
					y1 = (y - y1) / 2;
					A26.nLeft = x - x1;
					A26.nRight = x + x1;
					A26.nUp = y - y1;
					A26.nDown = y + y1;
					break;
		case 'T':   while (!kbhit())
						{
						GetJoystick(&x,&y);
						if (x < A26.nLeft) puts("Left ");
						if (x > A26.nRight) puts("Right ");
						if (y < A26.nUp) puts("Up ");
						if (y > A26.nDown) puts("Down ");
						printf("\n");
						}
					getch();
					break;
		case 'M':	A26.nUp = ReadInt("Up");
					A26.nDown = ReadInt("Down");
					A26.nLeft = ReadInt("Left");
					A26.nRight = ReadInt("Right");
					break;
		}
	}
while (ch != 'Q');

if (f = fopen("a26.com","rb+"),f == NULL) EXIT("Couldn't open a26.com");
if (fseek(f,32L,SEEK_SET) != 0) EXIT("Couldn't seek a26.com");
if (fwrite(&A26,sizeof(int) * 4,1,f) != 1) EXIT("Couldn't read a26.com");
fclose(f);

}
