/***************************************************************************

		Generate code for the main memory referencing instructions

 **************************************************************************/

#include <stdio.h>

char *szBase[8] =  { "ora","and","eor","adc","sta","lda","cmp","sbc" };

	/********************************/
	/* EAC is in BX,do the function */
	/********************************/

void dofunction(int n,int bZero)
{
char *s = (bZero ? "zread" : "read");
switch(n)
	{
	case 0:	printf("        %s dl,bx\n",s);
			printf("        or  al,dl\n");
			printf("        usetest al\n");
			break;

	case 1:	printf("        %s dl,bx\n",s);
			printf("        and al,dl\n");
			printf("        usetest al\n");
			break;

	case 2:	printf("        %s dl,bx\n",s);
			printf("        xor al,dl\n");
			printf("        usetest al\n");
			break;

	case 3:	printf("        call [AddVector]\n");
			printf("        usetest al\n");
			break;

	case 4:	printf("        %s al,bx\n",bZero ? "zwrite" : "write");
			break;

	case 5:	printf("        %s al,bx\n",s);
			printf("        usetest al\n");
			break;

	case 6:	printf("        call DoCmp\n");
			break;

	case 7:	printf("        call [SubVector]\n");
			printf("        usetest al\n");
			break;

	default:exit(0);
			break;
	}
}

	/********************/
	/* Generate a label */
	/********************/

void label(int n,char *szComment)
{
printf("op%02x:  ; ***** %s *****\n",n,szComment);
}

void main()
{
int n,nOpcode;
for (n = 0;n < 8;n++)
	{
	nOpcode = n * 0x20;
	printf(";\n; ******************* %s section ********************\n;\n",szBase[n]);

	label(nOpcode+1,"indirect x");
	printf("        indirectx\n");
	dofunction(n,0);
	printf("        ret\n");

	label(nOpcode+5,"zeropage");
	printf("        zeropage\n");
	dofunction(n,1);
	printf("        ret\n");

	if (n != 4)							/* can't store immediate ! */
		{
		label(nOpcode+9,"immediate");
		printf("        mov bx,bp\n");
		printf("        inc bp\n");
		dofunction(n,0);
		printf("        ret\n");
		}

	label(nOpcode+0xD,"absolute");
	printf("        absolute\n");
	dofunction(n,0);
	printf("        ret\n");

	label(nOpcode+0x11,"indirect,y");
	printf("        indirecty\n");
	dofunction(n,0);
	printf("        ret\n");

	label(nOpcode+0x15,"zeropage,x");
	printf("        zeropagex\n");
	dofunction(n,1);
	printf("        ret\n");

	label(nOpcode+0x19,"absolute,y");
	printf("        absolutey\n");
	dofunction(n,0);
	printf("        ret\n");


	label(nOpcode+0x1D,"absolute,x");
	printf("        absolutex\n");
	dofunction(n,0);
	printf("        ret\n");

	}
fprintf(stderr,"Generated Main Memory Reference code.\n");
}