#include <stdio.h>

#define SET(m) ((i & m) != 0)

void main()
{
int i,n;
unsigned int w;
unsigned long l;
double fFreq,fVal;

/* Table to translate a display entry (pf,ball,p1,m1,p0,m0) into a
   word containing the collision flags to set.

   bit 0		m0-p1
   bit 1		m0-p0

   etc.....

*/

printf(";\n; Display to collision word\n;\nTIAColTab:\n");
for (i = 0;i < 64;i++)
	{
	w = 0;
	if (SET(32) && SET(4)) w = w | 2;		/* m0 & p1 */
	if (SET(32) && SET(16)) w = w | 1;		/* m0 & p0 */

	if (SET(8) && SET(16)) w = w | 8;		/* m1 & p0 */
	if (SET(8) && SET(4)) w = w | 4;		/* m1 & p1 */

	if (SET(16) && SET(1)) w = w | 32;		/* p0 & pf */
	if (SET(16) && SET(2)) w = w | 16;		/* p0 & bl */

	if (SET(4) && SET(1)) w = w | 128;		/* p1 & pf */
	if (SET(4) && SET(2)) w = w | 64;		/* p1 & bl */

	if (SET(32) && SET(1)) w = w | 512;		/* m0 & pf */
	if (SET(32) && SET(2)) w = w | 256;		/* m0 & bl */

	if (SET(8) && SET(1)) w = w | 2048;		/* m1 & pf */
	if (SET(8) && SET(2)) w = w | 1024;		/* m1 & bl */

	if (SET(1) && SET(2)) w = w | 8192;		/* pf & bl */

	if (SET(16) && SET(4)) w = w | 32768;	/* p0 & p1 */
	if (SET(32) && SET(8)) w = w | 16384;	/* m0 & m1 */

	printf("   dw %u ; %x\n",w,w);
	}

/* Table to translate a display entry (6 bits which are pf,ball,p1,m1,p0,m0)
   into a luminance register value . 2 of these,in the second, the
   playfield has priority ! */

printf(";\n");
printf("TIADisplayToColour:\n");
for (i = 0;i < 64;i++)
	{
	n = 0;						/* background */
	if (i & 3) n = 1;			/* playfield or ball */
	if (i & 12) n = 2;			/* p1,m1 */
	if (i & 48) n = 3;			/* p0,m0 */
	if (i % 16 == 0) printf(" db ");
	printf("%d",n);
	if (i % 16 != 15) printf(","); else printf("\n");
	}

printf(";\n");
printf("TIADisplayToColour2:\n");
for (i = 0;i < 64;i++)
	{
	n = 0;						/* background */

	if (i & 12) n = 2;			/* p1,m1 */
	if (i & 48) n = 3;			/* p0,m0 */
	if (i % 16 == 0) printf(" db ");
	if (i & 3) n = 1;			/* playfield or ball */
	printf("%d",n);
	if (i % 16 != 15) printf(","); else printf("\n");
	}

/* Table of 8 bit reflected values */

printf(";\n");
printf("TIAReflect8:\n");
for (i = 0;i < 256;i++)
	{
	n = 0;
	if (i & 1) n = n | 128;
	if (i & 2) n = n | 64;
	if (i & 4) n = n | 32;
	if (i & 8) n = n | 16;
	if (i & 16) n = n | 8;
	if (i & 32) n = n | 4;
	if (i & 64) n = n | 2;
	if (i & 128) n = n | 1;

	if (i % 16 == 0) printf(" db ");
	printf("%d",n);
	if (i % 16 != 15) printf(","); else printf("\n");
	}

/* BCD to Decimal */

printf(";\n");
printf("TIABCDToDec:\n");
for (i = 0;i < 256;i++)
	{
	n = (i >> 4) * 10 + (i & 0xF);

	if (i % 16 == 0) printf(" db ");
	printf("%d",n);
	if (i % 16 != 15) printf(","); else printf("\n");
	}

/* Decimal to BCD */

printf(";\n");
printf("TIADecToBCD:\n");
for (i = 0;i < 256;i++)
	{
	n = (i % 10) + (i / 10 % 10) * 16;
	if (i % 16 == 0) printf(" db ");
	printf("%d",n);
	if (i % 16 != 15) printf(","); else printf("\n");
	}

/* Table # to shrunk table for -v screen */

printf(";\nTIAShrunk:\n;\n");
n = 0;
for (i = 0;i < 225;i++)
	{
	if (i % 8 != 0) printf("db %d\n",n++);
	else printf("db -1\n");
	}

/* Frequency table for PC Speaker */

printf(";\nFrequency:\n;\n");
for (i = 0;i < 32;i++)
	{
	fFreq = 30000.0 / ((double)(i+1));
	fVal = 1193280.0 / fFreq;
	l = (long)fVal;
	printf(" dw %ld ; %.2f Hz\n",l,fFreq);
	}

/* Frequency table for ADLIB Card */

printf(";\nFreqAdLib:\n;\n");
for (i = 0;i < 32;i++)
	{
	fFreq = 30000.0 / ((double)(i+1));
	l = (long)fFreq;

	printf(" dw %ld ; %.2f Hz\n",l,fFreq);
	}

}